#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long int n;
    cin >> n;

    vector<long long int> a(n);
    for(long long int i = 0; i < n; i++)
        cin >> a[i];

    long long int temp;
    long long int result = 0;
    vector<pair<long long int, long long int>> change;

    long long int iter = n - 1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < iter; j++) {
            if(a[j] > a[j + 1]) {
                temp = a[j];
                a[j] = a[j + 1];
                a[j + 1] = temp;

                result++;
                change.push_back(make_pair(j + 1, j + 2));
            }
        }
    }

    cout << result << endl;
    for(pair<int, int> v: change) {
        cout << v.first << " " << v.second << endl;
    }
}